use super::*;
use job::Job;
use std::io::{self, Read};

pub fn work_on(job: &mut Job) -> io::Result<usize>
{
    let output = job.output_slice();
    let output = unsafe {
	// SAFETY: Required because the compiler thinks we're mutably borrowing the same data later on, even though they are unrelated fields of the struct
	std::slice::from_raw_parts_mut(output.as_mut_ptr(), output.len())
    };
    
    let mut read=0;
    while read < job.len() {
	match job.read(&mut output[read..])? {
	    0 => break,
	    current => read+=current,
	}
    }
    Ok(read)
}
